
//****** UTILIDADES VARIAS *************
#include <stdio.h>	
#if defined(__GNUC__) && !defined(__MINGW32__) && !defined(__MINGW64__)

static int GetTickCount() {

    struct timeval t;
    gettimeofday(&t, NULL);
    return t.tv_sec*1000 + t.tv_usec/1000;
}

#endif


static int GetTime() {
	return GetTickCount();
}


#if defined(__GNUC__) && !defined(__MINGW32__) && !defined(__MINGW64__)

#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <fcntl.h>


static int kbhit(void)
{
  struct termios oldt, newt;
  int ch;
  int oldf;

  tcgetattr(STDIN_FILENO, &oldt);
  newt = oldt;
  newt.c_lflag &= ~(ICANON | ECHO);
  tcsetattr(STDIN_FILENO, TCSANOW, &newt);
  oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
  fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);

  ch = getchar();

  tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
  fcntl(STDIN_FILENO, F_SETFL, oldf);

  if(ch != EOF)
  {
    ungetc(ch, stdin);
    return 1;
  }

  return 0;
}

#define _kbhit  kbhit

/* Non-windows version */
int CheckInput(void) {
  fd_set readfds;
  struct timeval timeout;

  FD_ZERO(&readfds);
  FD_SET(fileno(stdin), &readfds);
   /* Set to timeout immediately */
  timeout.tv_sec = 0;
  timeout.tv_usec = 0;
  select(16, &readfds, 0, 0, &timeout);

  return (FD_ISSET(fileno(stdin), &readfds));
}

#else

/* Windows-version */
// with this version of CheckInput(), Betsabe has problems in mode (ponder on) .........????
/*
int CheckInput(void) {
  static int init = 0, pipe;
  static HANDLE inh;
  DWORD dw;
   // If we're running under XBoard then we can't use _kbhit() as the input commands
   // are sent to us directly over the internal pipe

    if (!init) {
      init = 1;
      inh = GetStdHandle(STD_INPUT_HANDLE);
      pipe = !GetConsoleMode(inh, &dw);
      if (!pipe) {
        SetConsoleMode(inh, dw & ~(ENABLE_MOUSE_INPUT | ENABLE_WINDOW_INPUT));
        FlushConsoleInputBuffer(inh);
      }

    if (pipe) {
      if (!PeekNamedPipe(inh, NULL, 0, NULL, &dw, NULL)) return 1;
      return dw;
    }
    else {
      GetNumberOfConsoleInputEvents(inh, &dw);
      return dw <= 1 ? 0 : dw;
    }
  }
  else return _kbhit();
}

*/

//* Para saber si WinBoard nos llama
int CheckInput(void)
{
	static int init = 0, pipe;
	static HANDLE inh;
	DWORD dw;

	if (!init) {
		init = 1;
		inh = GetStdHandle(STD_INPUT_HANDLE);
		pipe = !GetConsoleMode(inh, &dw);
		if (!pipe) {
			SetConsoleMode(inh, dw & ~(ENABLE_MOUSE_INPUT|ENABLE_WINDOW_INPUT));
			FlushConsoleInputBuffer(inh);
		}
	}
	if (pipe) {
		if (!PeekNamedPipe(inh, NULL, 0, NULL, &dw, NULL)) {
			return 1;
		}
		return dw;
	} else {

		GetNumberOfConsoleInputEvents(inh, &dw);
		return dw <= 1 ? 0 : dw;
	}

}

#endif

//* nos dice el movimiento que ha jugado
void muestra_mov(int MovAct)
{
   char casillatexto[5];
   int origen,destino;
   origen=ListaMov[MovAct].origen;
   destino=ListaMov[MovAct].destino;

   if (wboard){
	printf("move %s",ca_algebraica(origen,casillatexto));
	printf("%s",ca_algebraica(destino,casillatexto));
    if(ListaMov[MovAct].promocion!=VACIO)
      printf("%c",SimboloFichawb[ListaMov[MovAct].promocion]);
	printf("  ");
	printf("\n");
	fflush(stdout);
   }
   else {
   printf("%c",SimboloFicha[abs(contenido[origen])]);
   printf("%s",ca_algebraica(origen,casillatexto));

   if(ListaMov[MovAct].capturada==VACIO) printf("-");
   else printf("x");

   printf("%s",ca_algebraica(destino,casillatexto));
   if(ListaMov[MovAct].promocion!=VACIO) {
      printf("%c",SimboloFicha[ListaMov[MovAct].promocion]);
   }

   }
   return;
}

//* actualizamos la variante principal con otro movimiento
void ActVarPrincipal(int MovAct)
{
   int i;

   VarPrinc[Profundidad][Profundidad].origen=ListaMov[MovAct].origen;
   VarPrinc[Profundidad][Profundidad].destino=ListaMov[MovAct].destino;
   VarPrinc[Profundidad][Profundidad].capturada = ListaMov[MovAct].capturada;
   VarPrinc[Profundidad][Profundidad].ficha = abs(contenido[ListaMov[MovAct].origen]);
   for(i=1;;i++) {
      if(VarPrinc[Profundidad+1][Profundidad+i].origen==0) {
         VarPrinc[Profundidad][Profundidad+i]=VarPrinc[Profundidad+1][Profundidad+i];
	  return;
      }
   VarPrinc[Profundidad][Profundidad+i]=VarPrinc[Profundidad+1][Profundidad+i];
   }
}

//* para mostrar los movimiento de la variante principal
void MuestraVarPrinc(int ply, int eval)
{

   int i;
   int minutos = 0;
   int segundos =0;
   int crono =0;
   char textorigen[5],textdestino[5];
   float nowb;

if (stop_search == false) {
    segundos = (GetTime()-start_time)/1000;
     if(segundos > 60){
	    minutos = segundos/60,
		segundos = segundos-(minutos * 60);
   }
	 if(minutos >0)crono = segundos + (minutos*60);
	 else if( segundos >0)crono = segundos;
	 else crono = Nodos;

   if(wboard) { // modo winboard
    printf("%d %6d %d %d    ", ply,eval,((GetTime()-start_time)/10),Nodos);
    fflush(stdout);

   for(i=0;;i=i+1) {
      if(VarPrinc[0][i].origen==0) {
		  printf("\n");
		  fflush(stdout);
	      break;
      }
      if(VarPrinc[0][i].capturada)
      printf("%c%sx%s ",SimboloFichawb2[VarPrinc[0][i].ficha],
	          ca_algebraica(VarPrinc[0][i].origen,textorigen),
		      ca_algebraica(VarPrinc[0][i].destino,textdestino));
	  else
      printf("%c%s-%s ",SimboloFichawb2[VarPrinc[0][i].ficha],
	          ca_algebraica(VarPrinc[0][i].origen,textorigen),
		      ca_algebraica(VarPrinc[0][i].destino,textdestino));
    
      if(i >10) {
		printf("\n");
		fflush(stdout);
		break;
		}
   } return;
   }

   else { // estamos en modo consola
	   nowb = eval;
       printf("                                                    \r");
       printf("%2d)  %2d:%2d  %5.2f %7d n/s  ",
	   ply,minutos,segundos,nowb/100,Nodos/Max(1,crono));

   for(i=0;;i=i+1) {
      if(VarPrinc[0][i].origen==0) break;

      if(VarPrinc[0][i].capturada)
      printf("%sx%s ",ca_algebraica(VarPrinc[0][i].origen,textorigen),
		              ca_algebraica(VarPrinc[0][i].destino,textdestino));
	  else
      printf("%s-%s ",ca_algebraica(VarPrinc[0][i].origen,textorigen),
		              ca_algebraica(VarPrinc[0][i].destino,textdestino));
      if(i >6) 	break;
   }//for
   }// else
   }//stop_search

   printf("\n");
   return;
}

//* Esta rutina se encarga de leer una posicion en formato FEN
//* y esta adaptada de la realizada por Normand Blais para TSCP
//* http://www.tckerrigan.com/Chess/TSCP

void setboard_fen(const char *cadena)
{
	int n,i,a,z;
	int casilla;
	n = strlen(cadena);

 for(i = 0; i < 120; i++) {
      contenido[i] = Tablero_Vacio[i];
   }

	casilla = A8;

	for (i = 0, z = 0; i < n && z == 0; ++i) {
		switch(cadena[i]) {
		case '1': casilla += 1; break;
		case '2': casilla += 2; break;
		case '3': casilla += 3; break;
		case '4': casilla += 4; break;
		case '5': casilla += 5; break;
		case '6': casilla += 6; break;
		case '7': casilla += 7; break;
		case '8': casilla += 8; break;

		case 'p': contenido[casilla] = P_N;  ++casilla; break;
		case 'n': contenido[casilla] = C_N;  ++casilla; break;
		case 'b': contenido[casilla] = A_N;  ++casilla; break;
		case 'r': contenido[casilla] = T_N;  ++casilla; break;
		case 'q': contenido[casilla] = D_N;  ++casilla; break;
		case 'k': contenido[casilla] = R_N;  Pos_RN = casilla; ++casilla; break;
		case 'P': contenido[casilla] = P_B;  ++casilla; break;
		case 'N': contenido[casilla] = C_B;  ++casilla; break;
		case 'B': contenido[casilla] = A_B;  ++casilla; break;
		case 'R': contenido[casilla] = T_B;  ++casilla; break;
		case 'Q': contenido[casilla] = D_B;  ++casilla; break;
		case 'K': contenido[casilla] = R_B;  Pos_RB = casilla;  ++casilla; break;
		case '/': casilla -= 18; break;
		default: z = 1; break;
		}//switch
		a = i;
	}//for

	++a;

	for (i = a, z = 0; i < n && z == 0; ++i) {
		switch(cadena[i]) {
		case 'w': Color = BLANCAS; break;
		case 'b': Color = NEGRAS;  break;
		default: z = 1; break;
		}
		a = i;
	}

	enrocado_B = true;
	enrocado_N = true;

    for(i = A1; i <= H8; i++) {
      Movida[i] = 1;
   }
	for (i = a+1, z = 0; i < n && z == 0; ++i) {
		switch(cadena[i]) {
		case 'K': {
			enrocado_B = false;
			Movida[E1]=0;
			Movida[H1]=0;
			break;}
		case 'Q': {
			enrocado_B = false;
			Movida[E1]=0;
			Movida[A1]=0;
			break;}
		case 'k': {
			enrocado_N = false;
			Movida[E8]=0;
			Movida[H8]=0;
			break;}
		case 'q': {
			enrocado_N = false;
			Movida[E8]=0;
			Movida[A8]=0;
			break;}
		case '-': break;
		default: z = 1; break;
		}
		a = i;
	}

    Alpaso = ILEGAL;

	for (i = a+1, z = 0; i < n && z == 0; ++i) {
		switch(cadena[i]) {
		case '-': break;
		case 'a': Alpaso =   1; break;
		case 'b': Alpaso =   2; break;
		case 'c': Alpaso =   3; break;
		case 'd': Alpaso =   4; break;
		case 'e': Alpaso =   5; break;
		case 'f': Alpaso =   6; break;
		case 'g': Alpaso =   7; break;
		case 'h': Alpaso =   8; break;
		case '1': Alpaso += 20; break;
		case '2': Alpaso += 30; break;
		case '3': Alpaso += 40; break;
		case '4': Alpaso += 50; break;
		case '5': Alpaso += 60; break;
		case '6': Alpaso += 70; break;
		case '7': Alpaso += 80; break;
		case '8': Alpaso += 90; break;
		default: z = 1; break;
		}//switch
	} //for

   MaterialBB= 0;
   FichasBB = 0;
   PeonesBB = 0;
   MaterialNN= 0;
   FichasNN = 0;
   PeonesNN = 0;

   for(i=A1;i<=H8;i=i+1) {
      if((contenido[i]==VACIO)||(contenido[i]== FUERA)
		  || abs(contenido[i])== R_B) {
	 continue;
      }
	  if(contenido[i]>0) {
          MaterialBB += ValFicha[abs(contenido[i])];
		  if(contenido[i] == P_B ) {
			  PeonesBB++;}
		  else {
			  FichasBB++;
		  }
	  }
	  else {

           MaterialNN += ValFicha[abs(contenido[i])];
		   if(contenido[i] == (-1) ) {
			   PeonesNN++;}
           else {
			  FichasNN++;
		   }
	  }
    }//for
   if(contenido[Pos_RB]==VACIO || contenido[Pos_RN]==VACIO){
    printf("tellusererror Illegal position\n");
	fflush(stdout);
	newgame();
   }

if(contenido[B1]==C_B) Movida[B1]=0; if(contenido[C1]==A_B) Movida[C1]=0;
if(contenido[G1]==C_B) Movida[G1]=0; if(contenido[F1]==A_B) Movida[F1]=0;
if(contenido[A1]==T_B) Movida[A1]=0; if(contenido[H1]==T_B) Movida[H1]=0;

if(contenido[B8]==C_N) Movida[B8]=0; if(contenido[C8]==A_N) Movida[C8]=0;
if(contenido[G8]==C_N) Movida[G8]=0; if(contenido[F8]==A_N) Movida[F8]=0;
if(contenido[A8]==T_N) Movida[A8]=0; if(contenido[H8]==T_N) Movida[H8]=0;

   modotest		 = true;
   PilaMax[0]    =  0;
   MAX_PLY       = 60;
   Profundidad   =  0;
   fifty         =  2;
   hply          =  0;
   set_hash();
   clear_hash();
}


/** Para saber que distancia hay entre dos casilla       */

int Dist(int cas1, int cas2){
int Dif_Col, Dif_Fil;

Dif_Fil = abs((cas1/10)-(cas2/10));
Dif_Col = abs((cas1%10)-(cas2%10));
if(Dif_Fil > Dif_Col)
return Dif_Fil;
else return Dif_Col;
}


/** Input es una rutina auxiliar utilizada por otras rutinas,
 ** como leecomando() y controla lo introducido por el teclado,
 ** ademas se le puede llamar con un texto explicativo del tipo
 ** de dato que espera recibir.
 */

str input(str text,str comando)
{
   int i;

   printf("%s",text);
   gets(comando);
 
   for(i = 0; comando[i]!= 0; i++) {
	   comando[i] = toupper(comando[i]);
   }

   return comando;
}

void help(void)
{
printf("                                                 \n");
printf(" q, quit, exit    = exit program\n");
printf(" e2e4, e7e8q      = do a move\n");
printf(" new              = new game\n");
printf(" d                = print board\n");
printf(" auto             = auto-play 30 move\n");
printf(" test             = test diverse positions 60 s, \n");
printf(" r                = undo a move\n");
printf(" c                = change color to play\n");
printf(" dos              = force\n");
printf(" go               = computer play\n");
printf(" n                = level (1=10s, 2=20s.. 13=ply\n");
printf("                                                 \n");
}
/*** Esta rutina nos permitir interpretar el comando introducido por el
 *** usuario, si no es ningn comando reconocido, entonces se comprueba
 *** si se trata de una jugada legal, de lo contrario emitimos un mensaje
 *** de comando no reconocido.*/

void lee_comando(void)
{
   char comando[80];
   bool  final = false;

   do {

    input("Su jugada: ",comando);

    if(strcmp(comando,"XBOARD") == 0){
		wboard = true;
	    xboard();
		free_hash(); // CHANGE add by Alex Guerrero
        exit(1); // CHANGE add by Alex Guerrero
	  }

	else if(    strcmp(comando,"Q")==0
		|| strcmp(comando,"QUIT")==0
		|| strcmp(comando,"EXIT")==0) {
	    final = true;
      }
	else if(strcmp(comando,"HELP")==0
		 || strcmp(comando,"AYUDA")==0 )
		help();
	else if(strcmp(comando,"PONDER")==0)
		ponderar = true;
	else if(strcmp(comando,"TEST")==0)
		Test();

    else if(strcmp(comando,"NEW")==0){
		free_hash();
		newgame();
	}
    else if(strcmp(comando,"D")==0)
		dibuja_tablero();
    else if(strcmp(comando,"R")==0) {
        if (hply > 1){
			retrocede();
			Profundidad = 1;
			dibuja_tablero();
		}
	}
    else if(strcmp(comando,"C")==0) {
	    if(Color == BLANCAS) Color = NEGRAS;
	    else Color = BLANCAS;
	}
    else if(strcmp(comando,"GO")==0) {
		DosJugadores= false;
		computer_mov();
      }
    else if(strcmp(comando,"AUTO")==0) {
		int x;
		DosJugadores= false;
		for(x =1;x<=30; x++)
		computer_mov();
      }
    else if(strcmp(comando,"DOS")==0) {

		if(DosJugadores == false){
		   DosJugadores =  true;
           printf(" Jugador-Jugador SI");
		}
		else {
		   DosJugadores = false;
		   printf(" Jugador-Jugador NO");
		}
      }
    else if(strcmp(comando,"N")==0)
		inputnivel();
    else {  // Vale comprobamos que sea una jugada legal
		if((input_mov(comando)) == false)
			printf("Jugada ilegal o Comando no reconocido\n");
		else if(DosJugadores== false) {
			dibuja_tablero();
			computer_mov();
	    }
     }
   }
   while(final == false);
free_hash();
exit (1);
}


//* Para cambiar el nivel de juego, en modo consola
void
inputnivel(void)
{
   char texto[20];
   int temporal;
   input(" Nivel: ",texto);
   temporal=(int)atol(texto);

   if(temporal == 13){
   input(" Ply: ",texto);
   temporal=(int)atol(texto);
   MAX_PLY = temporal;
   maxtiempo =  1 << 25;}
   else {
      maxtiempo = temporal * 1000;
      printf("Nivel= %d segundos\n",maxtiempo);
   }
}

/*** Input_mov() se encarga de leer nuestro movimiento, primero comprueba que lo
 *** introducido no sea menor de 4 caracteres, luego genera una lista de todas las
 *** jugadas pseudolegales para la posicin actual, y comprueba si alguna de ellas
 *** coincide con la jugada que hemos introducido, sino es as no la admite; tam-
 *** bien comprueba si es una subopromocin (e7e8C).
 *** Si todo ha sido correcto comprobamos que la jugada sea legal, probamos a hacer
 *** el movimiento y miramos si tenemos el Rey en Jaque, con lo cual retrocede el
 *** movimiento de prueba, y nos dice que tenemos el Rey en Jaque.*/

int input_mov(str jugada)
{
   int origen,destino,i;
   char casillatexto[3];

   for(i = 0; jugada[i]!= 0; i++)
   jugada[i]=toupper(jugada[i]);
   // Si tiene menos de 4 caracteres no es un movimiento
   if(strlen(jugada)<4)
      return false;

   origen =  ca_numerica(jugada);
   destino = ca_numerica(&jugada[2]);
   genera_todo();
   for(i=PilaMax[Profundidad]; i<PilaMax[Profundidad+1]; i++) {
      if((ListaMov[i].origen==origen)&&(ListaMov[i].destino==destino)) {
	 if(ListaMov[i].promocion!=VACIO) {
	    if(jugada[4] == 'R' || jugada[4] == 'T') i = i+1;
	    else if(jugada[4] =='B' || jugada[4] == 'A') i = i+2;
	    else if(jugada[4] =='N' || jugada[4] == 'C') i = i+3;
	 }
    Profundidad = 0;
	MakeMove(i);

	 if(Color==NEGRAS) {
	    if(casilla_atacada(Pos_RB,NEGRAS)== true) {
	       printf("\nRey blanco en %s en jaque\n",
		      ca_algebraica(Pos_RB,casillatexto));
	       retrocede();
	       return false;
	    }
	 }
	 else if(casilla_atacada(Pos_RN,BLANCAS)== true) {
	    printf("\nRey negro en %s en jaque\n",
		   ca_algebraica(Pos_RN,casillatexto ));
	    retrocede();
	    return false;
	 }
	 return true;
      }
   }
   //* lo recibido no coincide con ninguno de los mov generados
   return false;
}

//** Colores disponibles para el fondo

#define BG_BLACK (0)     //0
#define BG_NAVY (16)     //BACKGROUND_BLUE
#define BG_GREEN (32)    //BACKGROUND_GREEN
#define BG_TEAL (48)     //BACKGROUND_BLUE | BACKGROUND_GREEN
#define BG_MAROON (64)   //BACKGROUND_RED
#define BG_PURPLE (80)   //BACKGROUND_BLUE | BACKGROUND_RED
#define BG_OLIVE (96)    //BACKGROUND_GREEN | BACKGROUND_RED
#define BG_SILVER (112)  //BACKGROUND_BLUE | BACKGROUND_GREEN | BACKGROUND_RED
#define BG_GRAY (128)    //BACKGROUND_INTENSITY
#define BG_BLUE (144)    //BACKGROUND_BLUE | BACKGROUND_INTENSITY
#define BG_LIME (160)    //BACKGROUND_GREEN | BACKGROUND_INTENSITY
#define BG_CYAN (176)    //BACKGROUND_BLUE | BACKGROUND_GREEN | BACKGROUND_INTENSITY
#define BG_RED (192)     //BACKGROUND_RED | BACKGROUND_INTENSITY
#define BG_MAGENTA (208) //BACKGROUND_BLUE | BACKGROUND_RED | BACKGROUND_INTENSITY
#define BG_YELLOW (224)  //BACKGROUND_GREEN | BACKGROUND_RED | BACKGROUND_INTENSITY
#define BG_WHITE (240)   //BACKGROUND_BLUE | BACKGROUND_GREEN | BACKGROUND_RED | BACKGROUND_INTENSITY

//** Colores disponibles para las letras

#define FG_BLACK (0)    //0
#define FG_NAVY (1)     //FOREGROUND_BLUE
#define FG_GREEN (2)    //FOREGROUND_GREEN
#define FG_TEAL (3)     //FOREGROUND_BLUE | FOREGROUND_GREEN
#define FG_MAROON (4)   //FOREGROUND_RED
#define FG_PURPLE (5)   //FOREGROUND_BLUE | FOREGROUND_RED
#define FG_OLIVE (6)    //FOREGROUND_GREEN | FOREGROUND_RED
#define FG_SILVER (7)   //FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_RED
#define FG_GRAY (8)     //FOREGROUND_INTENSITY
#define FG_BLUE (9)     //FOREGROUND_BLUE | FOREGROUND_INTENSITY
#define FG_LIME (10)    //FOREGROUND_GREEN | FOREGROUND_INTENSITY
#define FG_CYAN (11)    //FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_INTENSITY
#define FG_RED (12)     //FOREGROUND_RED | FOREGROUND_INTENSITY
#define FG_MAGENTA (13) //FOREGROUND_BLUE | FOREGROUND_RED | FOREGROUND_INTENSITY
#define FG_YELLOW (14)  //FOREGROUND_GREEN | FOREGROUND_RED | FOREGROUND_INTENSITY
#define FG_WHITE (15)   //FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_RED | FOREGROUND_INTENSITY


#if defined(_WIN32) || defined(_WIN64)

void dibuja_tablero()
{
   short x,y,c;
   short z = 8;
   short casilla;

HANDLE hStdInput = INVALID_HANDLE_VALUE,
hStdOutput = INVALID_HANDLE_VALUE;
hStdInput = GetStdHandle(STD_INPUT_HANDLE);
hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);

   printf("\n\n");
   for(y=0;y<8;y++) {
	SetConsoleTextAttribute(hStdOutput,BG_BLACK | FG_LIME);
	printf("   ");

	 if(y == 0 || y == 2 || y == 4 || y == 6){
		for(c=0;c<=3;c++) {
		SetConsoleTextAttribute(hStdOutput,BG_CYAN | FG_YELLOW);
		  printf("     ");
		SetConsoleTextAttribute(hStdOutput,BG_BLUE | FG_YELLOW);
		printf("     ");}
        SetConsoleTextAttribute(hStdOutput,BG_BLACK | BG_BLACK);
        printf("     ");
		printf("\n");}

	else{
		for(c=0;c<=3;c++) {
		SetConsoleTextAttribute(hStdOutput,BG_BLUE | FG_YELLOW);
		  printf("     ");
		SetConsoleTextAttribute(hStdOutput,BG_CYAN | FG_YELLOW);
		printf("     ");}
        SetConsoleTextAttribute(hStdOutput,BG_BLACK | BG_BLACK);
          printf("     ");
		  printf("\n");}// for c

		SetConsoleTextAttribute(hStdOutput,BG_BLACK | FG_LIME);
		printf(" %d ",z);

		z= z-1;
		for(x=1;x<=8;x++) {
		casilla=((z+2)*10+x);

	 if (contenido[casilla] == VACIO) {
		if (COLOR_CA[casilla])
		SetConsoleTextAttribute(hStdOutput,BG_BLUE | FG_YELLOW);
		else
		SetConsoleTextAttribute(hStdOutput,BG_CYAN | FG_YELLOW);
		printf("     ");} // vacio

	else
		 if (contenido[casilla] > 0) {

		if (COLOR_CA[casilla])
		SetConsoleTextAttribute(hStdOutput,BG_BLUE | FG_YELLOW);
		else
		SetConsoleTextAttribute(hStdOutput,BG_CYAN | FG_YELLOW);
			 switch (contenido[casilla]){
			 case P_B : printf("  P  "); break;
			 case C_B : printf("  C  "); break;
			 case A_B : printf("  A  "); break;
			 case T_B : printf("  T  "); break;
			 case D_B : printf("  D  "); break;
			 case R_B : printf("  R  "); break;
			 }

		 } // COLOR = BLANCO

	 else
		if (contenido[casilla] < 0) {

		if (COLOR_CA[casilla])
		SetConsoleTextAttribute(hStdOutput,BG_BLUE | FG_RED);
		else
		SetConsoleTextAttribute(hStdOutput,BG_CYAN | FG_RED);

				switch (contenido[casilla]){
			 case P_N : printf("  P  "); break;
			 case C_N : printf("  C  "); break;
			 case A_N : printf("  A  "); break;
			 case T_N : printf("  T  "); break;
			 case D_N : printf("  D  "); break;
			 case R_N : printf("  R  "); break;
			 }

		 } // COLOR = negro
      } //for x

	SetConsoleTextAttribute(hStdOutput,BG_BLACK | BG_BLACK);
	printf("     ");
    printf("\n");
   } // for y

	SetConsoleTextAttribute(hStdOutput,BG_BLACK | FG_LIME);
	printf("\n");
	printf("     a    b    c    d    e    f    g    h \n");
	printf("\n");

	

if(!wboard){
   if(Color==BLANCAS) {
      printf(" BLANCAS JUEGAN \n\n");
   }
   else printf(" NEGRAS JUEGAN  \n\n");
   }

   return;
}

#else

//** Lo dejo por si se prefiere un tablero compatible con
//** otros compiladores.

void dibuja_tablero()
{
   int i,j,ficha,color;

   printf("\n   +---+---+---+---+---+---+---+---+\n");
   for(i = 9; i >= 2; i--) {
	   printf(" %d ",i-1);
       for(j = 1; j <= 8; j++) {
	      ficha = contenido[i*10+j];
		  if(ficha > 0) color = 1;
		  else if(ficha < 0) color = -1;
		  else if(ficha == 0) color = 0;

	 ficha = abs(ficha);
	 if(color <0)
		printf("|*%c ",SimboloFicha[ficha]);
	 else
		printf("| %c ",SimboloFicha[ficha]);

      }
      printf("|\n");
      printf("   +---+---+---+---+---+---+---+---+\n");
   }
   printf("     a   b   c   d   e   f   g   h \n");
   printf("\n");

   if(!wboard){
   if(Color==BLANCAS) {
      printf(" BLANCAS JUEGAN \n");
   }
   else printf(" NEGRAS JUEGAN  \n");
   }
   return;
}

#endif


//**  Convertimos el nmero de una casilla a su representacion algebraica,
//**  por ejemplo si le damos 21, nos devuelve (A1)

str ca_algebraica(int canum,str caalg)
{
   if((canum<A1)||(canum>H8)||(contenido[canum]==FUERA)) {
     // strcpy_s(caalg,"--");//strcpy_s
	  strcat_s(caalg, _countof(caalg), "--");
   }
   else {
      caalg[0]='a'- 1 + canum%10;
      caalg[1]='1'- 2 + (canum/10);
      caalg[2]=0;
   }
   return caalg;
}

//** Convertimos una casillas algebraica en su numeracin correspondiente, es la
//** inversa de la rutina anterior, ejemplo: si introducimos A1, nos devuelve 21.

int ca_numerica(str caalg)
{
   if((caalg[0]<'A')||(caalg[0]>'H')||
      (caalg[1]<'1')||(caalg[1]>'8')) {
      return ILEGAL;
   }
   return (caalg[0]-'A'+1) + 10*(caalg[1]-'1'+2);
}






