
/******************** PROTOCOLO WINBOARD ********************/

// Ultima revision, noviembre 2011.
// Funciona bien con Arena y Winboard, no se como se comporta
// en otros tableros tipo Fritz.
// En las proximas revisiones intentaremos dar respuesta al
// maximo numero de comandos posible.

/*
// crt_sscanf_s.c
// This program uses sscanf_s to read data items
// from a string named tokenstring, then displays them.



int main(void)
{
	char  tokenstring[] = "15 12 14...";
	char  s[81];
	char  c;
	int   i;
	float fp;

	// Input various data from tokenstring:
	// max 80 character string plus null terminator
	sscanf_s(tokenstring, "%s", s, (unsigned)_countof(s));
	sscanf_s(tokenstring, "%c", &c, (unsigned)sizeof(char));
	sscanf_s(tokenstring, "%d", &i);
	sscanf_s(tokenstring, "%f", &fp);

	// Output the data read
	printf_s("String    = %s\n", s);
	printf_s("Character = %c\n", c);
	printf_s("Integer:  = %d\n", i);
	printf_s("Real:     = %f\n", fp);
}

*/

#include <stdio.h>		
#include <string.h>
#include <stdlib.h>	

void xboard()
{  
#define neutro  2
   char line[256], comando[256];
   int  base = 0; //movimientos que hay que hacer    
   int  mpc = 0; // movimientos para control
   int  incremento = 0;
   int  maxtime = 0;
   int  op_time = 0;
   char minutos[4];	   
   int  segundos; 
   int  i;
   bool final = false;
   wboard = true;
   DosJugadores   =  false;
  
    
   do {

   fflush(stdout);	 
      if (!fgets(line, 256, stdin))
			return;
      if (line[0] == '\n')
			continue;
	  
      sscanf_s(line, "%s", comando, (unsigned)_countof(comando));
	  
		if (strcmp(comando,"protover") == 0){
			printf("feature name=0 myname=\"Betsabe_II %s\"\n",VERSION);
			printf("feature setboard=1 playother=1 colors=0 reuse=0\n");
			printf("feature analyze=1 ping=1 draw=0 variants=normal\n");
			printf("feature sigint=0 sigterm=0 ics=0 done=1\n");
			continue;
		}
		//nos indica si las caractersticas definidas son aceptadas o no
		if (strcmp(comando, "accepted") == 0) 	
			continue;
		
		if (strcmp(comando, "rejected") == 0)	
			continue;
		
		if (strcmp(comando, "xboard") == 0) 
			continue;
		
//* Aunque Arena no lo necesita, es necesario para WinBoard
	if (strcmp(comando,"ping") == 0){
        int n; 
        sscanf_s(line, "ping %d", &n);
        printf("pong %d\n",n);
		continue;
		}
	if (strcmp(comando,"setboard")==0){
		setboard_fen(line+9);
		continue;
	}

	if(strcmp(comando,"quit")==0) {
	
#if !defined(ExitProcess)
#define ExitProcess  exit
#endif
		ExitProcess(0);
      }

	if(strcmp(comando,"undo")==0) {
	  if(hply > 1){
		  retrocede();
		  Profundidad = 1;
	  }
	  continue;
}      
	if(strcmp(comando,"remove")==0) {
	  if(hply > 2) {
		  retrocede();
		  retrocede();
		  Profundidad = 1;
	  }
	  continue;
	}
//* ya no se utilizan sustituidos por playother 
	if(strcmp(comando,"white")==0){
	Color = BLANCAS; 
	Betsabe = NEGRAS;
    continue;
	}
	if(strcmp(comando,"black")==0){
	Color = NEGRAS; 
	Betsabe = BLANCAS;
	 continue;
	}
	if(strcmp(comando,"playother")==0) {
	DosJugadores = false;
	if(Color == BLANCAS) Betsabe = NEGRAS;
	else Betsabe = BLANCAS;
	continue;
   }
	if(strcmp(comando,"new")==0){
	free_hash();
	newgame();
	continue;
	}
	if(strcmp(comando,"easy")==0){
	ponderar = false;
	continue;
	}
	if(strcmp(comando,"hard")==0){
	ponderar = true;
	continue;
	} 
	if(strcmp(comando,"force")==0) {
	     DosJugadores =  true;
	     Betsabe = neutro;
	continue;
}     
//* De momento no funciona correctamente y esta desactivada
//* usar nivel infinito y move now
	if (strcmp(comando,"analyze")==0){
		ponderar = false;
		Analiza = true;
		Betsabe = neutro;
		maxtiempo =  1 << 25;
		computer_mov();
		
	continue;
   }

	if(strcmp(comando,"go")==0) {
	DosJugadores = false;
	Analiza = false;
	Betsabe = Color;
	computer_mov();
	continue;
	}  

	if (!strcmp(comando, "result")) {
     char result[256];
     sscanf_s(line,"result %s",result, (unsigned)_countof(result));
     DosJugadores =  true;
	 Betsabe = neutro;
     continue;
	}


//* Nivel a profundidad fija 
	if (strcmp(comando,"sd")==0){
	sscanf_s(line, "sd %d",&MAX_PLY);
	//tiempo infinito
    maxtiempo =  1 << 25;
	continue;
   }

//* Nos dice que tipo de nivel tenemos
//* minutos no lo utilizamos pero se tiene que leer
if (strcmp(comando, "level") == 0) {
	sscanf_s(line, "level %d %d %d", &base, minutos, &segundos);
	//sscanf_s(line, "level %h %h %d", &base, minutos, &segundos);// hhd lo sugirio VS
	mpc = base;	    
	incremento = segundos * 1000;	
    continue;
}
	if (strcmp(comando,"st")==0){
	sscanf_s(line, "st %d",&maxtiempo);
    maxtiempo *=  1000;
	continue;
   }
//* Nos dice el tiempo que le queda al contrario en centesimas de segundos	
	if (strcmp(comando, "otim") == 0) {
			sscanf_s(line, "otim %d", &op_time);
			op_time *= 10;
			//Crono_oponente = op_time;
			continue;
}
//* Nos dice el tiempo que nos queda en centesimas de segundos			
	if (strcmp(comando, "time") == 0) {
			sscanf_s(line, "time %d", &maxtime);
			
			//pasamos a milisegundos que es como trabajamos internamente
			maxtiempo = (maxtime * 10);
			    
			//partidas a finish
			if (mpc == 0 && incremento == 0) {
				
					if(op_time > maxtiempo)	
						 maxtiempo /= 30; // was 40
					else maxtiempo /= 20; // was 30
				
			}
			//partidas con incremento de tiempo
			else if (mpc == 0 && incremento > 0) {
					if(op_time > maxtiempo)	
					maxtiempo = maxtiempo / 30 + (incremento/2);// was 40
					else
					maxtiempo = maxtiempo / 20 + (incremento/2);// was 30
			}

			//es un nivel con control de tiempo
			else {
				if (Betsabe == BLANCAS) quedan = (mpc-hply/2)-1;
				else quedan =(mpc - hply/2);

					//se ha llegado al control, reseteamos
                    if (quedan == 0) {    
					maxtiempo = maxtiempo/(base-(base/10));
					mpc = mpc + base;
					quedan = base;
				    }

					else {
					//no queremos perder por tiempo en el ultimo momento
					if (quedan <= 3) maxtiempo = (maxtiempo-1000)/quedan;
					else maxtiempo = maxtiempo / Min(quedan,30);
					   // else maxtiempo = maxtiempo/(quedan);
					}
					
			}//con control
			
			continue;
		}//time
    
	if( strcmp(comando, "post")   == 0 || strcmp(comando, "nopost") == 0 ||
	     strcmp(comando, ".")      == 0 || strcmp(comando, "pause")  == 0 ||
	     strcmp(comando, "draw")   == 0 || strcmp(comando, "rating") == 0 || 
         strcmp(comando, "resume") == 0 || strcmp(comando, "?")      == 0 ||
		 strcmp(comando, "computer") == 0 || strcmp(comando, "random") == 0) {
	continue; 			
   }

 // Vale comprobamos que sea una jugada legal
else {
	
	if((input_mov(comando))== false){
		for(i = 0; comando[i]!= 0; i++) 
        comando[i] = tolower(comando[i]);
		 printf("Error (unknown command): %s\n",comando);
	}
 
	else if(Analiza ||
		   (DosJugadores == false && Betsabe == Color)) {  
            //(DosJugadores == false)) {  
		    en_tiempo_contrario = false;
	        computer_mov(); 
	}
}//else
	
}// do
   while(final == false);
free_hash();
exit (1);

} // xboard


