
/************************ GENERANDO MOVIMIENTOS *****************************/

//** Almacenamos una jugada normal, ordenandola en este orden
//** Jugada de las hash
//** Variante principal
//** Matekiller
//** Capturas
//** Movimientos Killer1 y Killer2
//** Resto, por las veces que han sido good_move

static void anota_jugada(int origen, int destino)
{
  if ((hashmov.origen  == origen) &&
      (hashmov.destino == destino))
    ListaMov[Index].eval = BONUS_HASH;

  else if ((matekiller[Profundidad].origen == origen) &&
           (matekiller[Profundidad].destino == destino))
    ListaMov[Index].eval = BONUS_MKIL;

  else if ((killer1[Profundidad].origen == origen) &&
           (killer1[Profundidad].destino == destino))
    ListaMov[Index].eval = BONUS_KIL1;

  else if ((killer2[Profundidad].origen == origen) &&
           (killer2[Profundidad].destino == destino))
    ListaMov[Index].eval = BONUS_KIL2;

  else ListaMov[Index].eval = good_mov[Color + 1][origen][destino];

  ListaMov[Index].origen      = origen;
  ListaMov[Index].destino     = destino;
  ListaMov[Index].capturada   = VACIO;
  ListaMov[Index].promocion   = VACIO;
  ListaMov[Index].enroquetipo = NO_ENROQUE;
  ListaMov[Index].cap_alpaso  = 0;
  Index++;
  return;
}

//*** Almacenamos una jugada-captura para Chearch() porque
//*** la ordenacion es diferente para QSearch(), ya que
//*** no tenemos movimientos de las hash

static void anota_captura(int origen, int destino)
{

  ListaMov[Index].origen    = origen;
  ListaMov[Index].destino   = destino;
  ListaMov[Index].capturada = abs(contenido[destino]);

//*** primero si es movimiento de las hash
  if ((hashmov.origen  == origen) &&
      (hashmov.destino == destino))
    ListaMov[Index].eval = BONUS_HASH;

  //captura matekiller
  else if ((matekiller[Profundidad].origen == origen) &&
           (matekiller[Profundidad].destino == destino))
    ListaMov[Index].eval += BONUS_MKIL;

// buena captura
  else if (ValFicha2[abs(contenido[destino])] >
           ValFicha2[abs(contenido[origen])])
    ListaMov[Index].eval = BONUS_BCAP +
                           (ValFicha[abs(contenido[destino])] * 16) -
                           ValFicha[abs(contenido[origen])];

  // captura igualada
  else if (ValFicha2[abs(contenido[destino])] ==
           ValFicha2[abs(contenido[origen])])
    ListaMov[Index].eval = BONUS_CAP +
                           (ValFicha[abs(contenido[destino])] * 16) -
                           ValFicha[abs(contenido[origen])];

  // vale, es una captura inferior, (mayor captura menor),
  // si ademas la capturada se encuentra defendida por un
  // peon, la consideramos una mala captura.
  else if (Mala_captura(origen, destino))
  {
    ListaMov[Index].eval = BONUS_MCAP +
                           (ValFicha[abs(contenido[destino])] * 16) -
                           ValFicha[abs(contenido[origen])];
  }

  // si no es el caso, la valoramos como una captura igualada
  else ListaMov[Index].eval = BONUS_CAP +
                                (ValFicha[abs(contenido[destino])] * 16) -
                                ValFicha[abs(contenido[origen])];

  ListaMov[Index].promocion   = VACIO;
  ListaMov[Index].enroquetipo = NO_ENROQUE;
  ListaMov[Index].cap_alpaso  = 0;
  Index++;
  return;
}

//** Almacenamos una jugada-captura para qsearch,
//** aqui no tenemos ni movimientos hash ni mateKiller, utilizamos
//** el sistema MVV/LVA, capturar la pieza mas valiosa, con la de
//** menos valor, esto reduce rapidamente el numero de variantes
//** en el arbol de busqueda.

static void anota_capturaq(int origen, int destino)
{

  ListaMov[Index].origen    = origen;
  ListaMov[Index].destino   = destino;
  ListaMov[Index].capturada = abs(contenido[destino]);

  //*** Primero si pertenece a la variante principal
  if ((VarPrinc[0][Profundidad].origen == origen) &&
      (VarPrinc[0][Profundidad].destino == destino))
    ListaMov[Index].eval += BONUS_VP;

  //** luego las capturas

  else	   ListaMov[Index].eval =
      (ValFicha2[abs(contenido[destino])] * 16) -
      ValFicha2[abs(contenido[origen])];


  ListaMov[Index].promocion   = VACIO;
  ListaMov[Index].enroquetipo = NO_ENROQUE;
  ListaMov[Index].cap_alpaso  = 0;
  Index++;
  return;
}

/*** Almacenamos una captura al paso ***/
static void anota_cap_alpaso(int origen, int destino, int ca_cap_alpaso)
{
  ListaMov[Index].origen      = origen;
  ListaMov[Index].destino     = destino;
  ListaMov[Index].capturada   = P_B;
  ListaMov[Index].promocion   = VACIO;
  ListaMov[Index].enroquetipo = NO_ENROQUE;
  ListaMov[Index].cap_alpaso  = ca_cap_alpaso;
  ListaMov[Index].eval        = BONUS_ALPASO;
  Index++;
  return;
}

/*** Almacenamos una jugada-promocion ***/
static void anota_promocion(int origen, int destino)
{
  int i;

  if (contenido[destino] == VACIO)
  {
    for (i = D_B; i > P_B; i--) // Probamos las 4 posibilidades
    {
      anota_jugada(origen, destino);
      ListaMov[Index - 1].promocion = i;

      if (i == D_B && ListaMov[Index - 1].eval < BONUS_PDAMA)
        ListaMov[Index - 1].eval = BONUS_PDAMA;

      else if (i == C_B && ListaMov[Index - 1].eval < BONUS_PCAB)
        ListaMov[Index - 1].eval = BONUS_PCAB;
    }

  }

  else
  {
    for (i = D_B; i > P_B; i--)
    {
      anota_captura(origen, destino);
      ListaMov[Index - 1].promocion = i;

      if (i == D_B) ListaMov[Index - 1].eval += 10000;

      else if (i == C_B) ListaMov[Index - 1].eval += 5000;
    }
  }
}

static void anota_promocionq(int origen, int destino)
{
  //en qsearch solo promocion a Dama
  if (contenido[destino] == VACIO)
  {
    anota_jugada(origen, destino);
    ListaMov[Index - 1].promocion = D_B;
    ListaMov[Index - 1].eval += BONUS_PDAMA;
  }

  else
  {
    //promocion con captura
    anota_captura(origen, destino);
    ListaMov[Index - 1].promocion = D_B;
    ListaMov[Index - 1].eval += 15000;
  }
}


//*** Esta rutina se encarga de verificar si el bando
//*** que ha movido ha dejado a su Rey en jaque

static int   es_legal()
{
  register int ca = 0;
  int i = 0;

  if (Color == BLANCAS)
  {
    register int origen = Pos_RN;

    //** Si el turno es de las BLANCAS, quiere decir que acaban
    //** de mover las NEGRAS

    // ALFIL Y DAMA
    for (ca = origen + 9;; ca += 9)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == A_B || contenido[ca] == D_B) return 0;

      break;
    }

    for (ca = origen - 9;; ca -= 9)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == A_B ||
          contenido[ca] == D_B) return 0;

      break;
    }

    for (ca = origen + 11;; ca += 11)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == A_B ||
          contenido[ca] == D_B) return 0;

      break;
    }

    for (ca = origen - 11;; ca -= 11)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == A_B ||
          contenido[ca] == D_B) return 0;

      break;
    }

    // TORRE Y DAMA
    for (ca = origen + 1;; ca += 1)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == T_B ||
          contenido[ca] == D_B) return 0;

      break;
    }

    for (ca = origen - 1;; ca -= 1)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == T_B ||
          contenido[ca] == D_B) return 0;

      break;
    }

    for (ca = origen + 10;; ca += 10)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == T_B ||
          contenido[ca] == D_B) return 0;

      break;
    }

    for (ca = origen - 10;; ca -= 10)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == T_B ||
          contenido[ca] == D_B) return 0;

      break;
    }

    //* El resto de comprobaciones, Caballo, peon y Rey, solo es
    //* necesario, si estamos en jaque o la ficha que se mueve es
    //* el Rey, sorprendentemente el resultado en nodos/segundos,
    //* es exactamente el mismo; para activarlos hay que incluir
    //* en es_legal(bool jaque,int destino).

    //if(jaque || destino == origen){
    // CABALLO
    for ( i = 0; i < 8; i++)
      if (contenido[origen + Inc_Ca[i]] == (C_B)) return 0;

    // PEON
    if (contenido[origen - 9] == P_B ||
        contenido[origen - 11] == P_B)return 0;

    // REY
    if (Distancia[Pos_RB][Pos_RN] == 1)return 0;

    //}//if(jaque || destino == origen)

    return 1;
  }//turno blancas

  else
  {
    register int origen = Pos_RB;

//ALFIL Y DAMA
    for (ca = origen + 9;; ca += 9)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == A_N || contenido[ca] == D_N) return 0;

      break;
    }

    for (ca = origen - 9;; ca -= 9)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == A_N || contenido[ca] == D_N) return 0;

      break;
    }

    for (ca = origen + 11;; ca += 11)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == A_N || contenido[ca] == D_N) return 0;

      break;
    }

    for (ca = origen - 11;; ca -= 11)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == A_N || contenido[ca] == D_N) return 0;

      break;
    }

    // TORRE Y DAMA
    for (ca = origen + 1;; ca += 1)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == T_N || contenido[ca] == D_N) return 0;

      break;
    }

    for (ca = origen - 1;; ca -= 1)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == T_N || contenido[ca] == D_N) return 0;

      break;
    }

    for (ca = origen + 10;; ca += 10)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == T_N || contenido[ca] == D_N) return 0;

      break;
    }

    for (ca = origen - 10;; ca -= 10)
    {
      if (contenido[ca] == VACIO) continue;

      if (contenido[ca] == T_N || contenido[ca] == D_N) return 0;

      break;
    }

//  if(jaque || destino == origen){
    // CABALLO
    for ( i = 0; i < 8; i++)
      if (contenido[origen + Inc_Ca[i]] == (C_N)) return 0;

    // PEON
    if (contenido[origen + 9] == P_N ||
        contenido[origen + 11] == P_N)return 0;

    // REY
    if (Distancia[Pos_RB][Pos_RN] == 1)return 0;

    //if(Distancia(Pos_RB,Pos_RN)== 1)return 0;
//  }
    return 1;
  }//turno negras
}//casilla atacada


int AlfilB_ataca(int casilla)
{
  int ca = 0 ;

  ca = casilla + 9;

  while (contenido[ca] == VACIO) ca += 9;

  if (contenido[ca] == A_B ) return 1;

  ca = casilla - 9;

  while (contenido[ca] == VACIO) ca -= 9;

  if (contenido[ca] == A_B ) return 1;

  ca = casilla + 11;

  while (contenido[ca] == VACIO) ca += 11;

  if (contenido[ca] == A_B ) return 1;

  ca = casilla - 11;

  while (contenido[ca] == VACIO) ca -= 11;

  if (contenido[ca] == A_B ) return 1;

  return 0;

}

int AlfilN_ataca(int casilla)
{
  int ca = 0 ;

  ca = casilla + 9;

  while (contenido[ca] == VACIO)ca += 9;

  if (contenido[ca] == A_N ) return 1;

  ca = casilla - 9;

  while (contenido[ca] == VACIO)ca -= 9;

  if (contenido[ca] == A_N ) return 1;

  ca = casilla + 11;

  while (contenido[ca] == VACIO)ca += 11;

  if (contenido[ca] == A_N ) return 1;

  ca = casilla - 11;

  while (contenido[ca] == VACIO)ca -= 11;

  if (contenido[ca] == A_N ) return 1;

  return 0;
}

static int casilla_atacada(int casilla, int turno)
{
  int register ca = 0 ;

  if (turno == BLANCAS)
  {

    //ALFIL Y DAMA
    ca = casilla + 9;

    while (contenido[ca] == VACIO) ca += 9;

    if (contenido[ca] == A_B || contenido[ca] == D_B) return 1;

    ca = casilla - 9;

    while (contenido[ca] == VACIO) ca -= 9;

    if (contenido[ca] == A_B || contenido[ca] == D_B) return 1;

    ca = casilla + 11;

    while (contenido[ca] == VACIO) ca += 11;

    if (contenido[ca] == A_B || contenido[ca] == D_B) return 1;

    ca = casilla - 11;

    while (contenido[ca] == VACIO) ca -= 11;

    if (contenido[ca] == A_B || contenido[ca] == D_B) return 1;

    // TORRE Y DAMA
    ca = casilla + 1;

    while (contenido[ca] == VACIO) ca += 1;

    if (contenido[ca] == T_B || contenido[ca] == D_B) return 1;

    ca = casilla - 1;

    while (contenido[ca] == VACIO) ca -= 1;

    if (contenido[ca] == T_B || contenido[ca] == D_B) return 1;

    ca = casilla + 10;

    while (contenido[ca] == VACIO) ca += 10;

    if (contenido[ca] == T_B || contenido[ca] == D_B) return 1;

    ca = casilla - 10;

    while (contenido[ca] == VACIO) ca -= 10;

    if (contenido[ca] == T_B || contenido[ca] == D_B) return 1;

    // CABALLO
    if (contenido[casilla + 8] == C_B)return 1;

    if (contenido[casilla - 8] == C_B)return 1;

    if (contenido[casilla + 12] == C_B)return 1;

    if (contenido[casilla - 12] == C_B)return 1;

    if (contenido[casilla + 19] == C_B)return 1;

    if (contenido[casilla - 19] == C_B)return 1;

    if (contenido[casilla + 21] == C_B)return 1;

    if (contenido[casilla - 21] == C_B)return 1;

    // PEON
    if (contenido[casilla - 9] == P_B ||
        contenido[casilla - 11] == P_B)return 1;

    // REY
    if (Distancia[Pos_RB][casilla] == 1)return 1;

    return 0;
  }//turno blancas

  else   // el turno es de las negras
  {

    //ALFIL Y DAMA
    ca = casilla + 9;

    while (contenido[ca] == VACIO)ca += 9;

    if (contenido[ca] == A_N || contenido[ca] == D_N) return 1;

    ca = casilla - 9;

    while (contenido[ca] == VACIO)ca -= 9;

    if (contenido[ca] == A_N || contenido[ca] == D_N) return 1;

    ca = casilla + 11;

    while (contenido[ca] == VACIO)ca += 11;

    if (contenido[ca] == A_N || contenido[ca] == D_N) return 1;

    ca = casilla - 11;

    while (contenido[ca] == VACIO)ca -= 11;

    if (contenido[ca] == A_N || contenido[ca] == D_N) return 1;

    // TORRE Y DAMA
    ca = casilla + 1;

    while (contenido[ca] == VACIO)ca += 1;

    if (contenido[ca] == T_N || contenido[ca] == D_N) return 1;

    ca = casilla - 1;

    while (contenido[ca] == VACIO)ca -= 1;

    if (contenido[ca] == T_N || contenido[ca] == D_N) return 1;

    ca = casilla + 10;

    while (contenido[ca] == VACIO)ca += 10;

    if (contenido[ca] == T_N || contenido[ca] == D_N) return 1;

    ca = casilla - 10;

    while (contenido[ca] == VACIO)ca -= 10;

    if (contenido[ca] == T_N || contenido[ca] == D_N) return 1;

    // CABALLO
    if (contenido[casilla + 8] == C_N)return 1;

    if (contenido[casilla - 8] == C_N)return 1;

    if (contenido[casilla + 12] == C_N)return 1;

    if (contenido[casilla - 12] == C_N)return 1;

    if (contenido[casilla + 19] == C_N)return 1;

    if (contenido[casilla - 19] == C_N)return 1;

    if (contenido[casilla + 21] == C_N)return 1;

    if (contenido[casilla - 21] == C_N)return 1;

    // PEON
    if (contenido[casilla + 9] == P_N ||
        contenido[casilla + 11] == P_N)return 1;

    // REY
    if (Distancia[Pos_RN][casilla] == 1)return 1;

    return 0;
  }//turno negras
}//casilla atacada


/*** Esta es nuestra rutina encargada de ir sacando los movimientos del
 *** almacen de movimientos generados, por orden, segun el valor que le
 *** dimos al generarlo y cada vez que saca un movimiento, no lo borra de la
 *** lista sino que le pone (eval -infinito), de forma que no se vuelva a coger.
 *** Cuando todos los movimientos de la lista tengan eval = -VALMATE, quiere
 *** decir que no quedan movimientos por sacar */

static int tomanextmov(void)
{
  int   mejor, i, siguiente;
  siguiente = -1;
  mejor     = -VALMATE;

//*** Repasamos todos los movimientos que aun quedan en la lista para devolver
//*** el que tenga mejor eval
  for (i = PilaMax[Profundidad]; i < PilaMax[Profundidad + 1]; i++)
  {
    if (ListaMov[i].eval > mejor)
    {
      siguiente = i;
      mejor     = ListaMov[i].eval;
    }
  }

  /*** Ya tenemos el mejor movimiento de la lista, pero lo marcamos para no
   *** volver a cogerlo */
  if (siguiente >= 0)
  {
    Eval_Last_Move = ListaMov[siguiente].eval;
    ListaMov[siguiente].eval = -VALMATE;
  }

  /*** Si haba algn movimiento en la lista se lo mandamos, en otro caso le
   *** devolvemos -1, que quiere decir que no quedan movimientos */
  return siguiente;
}



//*** HACER Y DESHACER MOVIMIENTOS,

//*** Hacemos un movimiento y actualizamos todas las
//*** variables que se ven implicadas

void MakeMove(int MovAct)
{
#define matcapturado  ValFicha[ListaMov[MovAct].capturada]
#define nuevomaterial ValFicha[ListaMov[MovAct].promocion]
#define caalpaso      ListaMov[MovAct].cap_alpaso
  int origen, destino;


  origen  = ListaMov[MovAct].origen;
  destino = ListaMov[MovAct].destino;
  Profundidad++;

  historial[hply].origen     = ListaMov[MovAct].origen;
  historial[hply].destino    = ListaMov[MovAct].destino;
  historial[hply].cap_alpaso = ListaMov[MovAct].cap_alpaso;
  historial[hply].promovida  = ListaMov[MovAct].promocion;
  historial[hply].capturada  = ListaMov[MovAct].capturada;
  historial[hply].enrocado   = ListaMov[MovAct].enroquetipo;
  historial[hply].alpaso     = Alpaso;
  historial[hply].hash       = hash;
  historial[hply].fifty      = fifty;
  hply++;

  if (Alpaso > 0) // borramos de las hash la casilla al paso
    hash ^= hash_alpaso[Alpaso];

  Alpaso = ILEGAL;
  Movida[origen]++;
  Movida[destino]++;

  //** Si se trata de una captura o lo movido es un peon
  //** actualizamos fifty para la regla de los 50 mov.
  if (contenido[origen] == P_B || contenido[origen] == P_N ||
      ListaMov[MovAct].capturada != VACIO)
    fifty = 0;

  else fifty++;

  if (Color == BLANCAS)
  {

//* Borramos de las hash, la ficha de la casilla origen
    //if(origen < A1 || origen > H8)
    // printf(" error......\n");
    hash = hash ^= zobrist[contenido[origen] + 7][origen];

    // Si es peon avanza 2 casillas, marcamos la nueva casilla alpaso
    if (contenido[ListaMov[MovAct].origen] == P_B)
    {
      if (destino - origen == 20)
      {
        Alpaso = origen + 10;
        // Incluimos en las hash la nueva casilla al paso
        hash ^= hash_alpaso[Alpaso];
      }
    }

    //** Miramos si es una captura al paso
    if (caalpaso > 0)
    {
      //Eliminamos el peon de las hash
      hash = hash ^= zobrist[P_N + 7][caalpaso];
      //Quitamos el peon que se ha capturado al paso
      contenido[caalpaso] = VACIO;
      MaterialNN -= VAL_P;
      PeonesNN--;
    }

    //** miramos si es una captura
    else if (ListaMov[MovAct].capturada != VACIO)
    {
      //Eliminamos lo capturado de las hash
      hash = hash ^= zobrist[(ListaMov[MovAct].capturada * -1) + 7][destino];
      // Actualizamos el material
      MaterialNN -= matcapturado;

      if (matcapturado != VAL_P) FichasNN--;

      else  PeonesNN--;
    }

    //** Actualizamos el contenido de las casillas
    //** de origen y destino
    contenido[destino] = contenido[origen];
    contenido[origen]  = VACIO;

    //** Es una promocion ?
    if (ListaMov[MovAct].promocion != VACIO)
    {
      contenido[destino] = ListaMov[MovAct].promocion;
      MaterialBB += (nuevomaterial - VAL_P);
      FichasBB++;
      PeonesBB--;
    }

    else   // Es un enroque corto ?..
    {
      if (ListaMov[MovAct].enroquetipo == ENROQUECORTO)
      {
        contenido[destino + 1] = VACIO; // destino es G1
        contenido[destino - 1] = T_B;
        enrocado_B = true;
        //Actualizamos el movimiento de torre en las hash
        hash = hash ^= zobrist[T_B + 7][H1];
        hash = hash ^= zobrist[T_B + 7][F1];
      }

      // Es un enroque largo ?..
      else if (ListaMov[MovAct].enroquetipo == ENROQUELARGO)
      {
        contenido[destino - 2] = VACIO;
        contenido[destino + 1] = T_B;
        enrocado_B = true;
        //Actualizamos el movimiento de torre en las hash
        hash = hash ^= zobrist[T_B + 7][A1];
        hash = hash ^= zobrist[T_B + 7][D1];
      }
    }

    // Actualizamos las hash con el destino de la movida
    hash = hash ^= zobrist[contenido[destino] + 7][destino];

    //** Actualizamos la posicion del Rey blanco
    if (contenido[destino] == R_B) Pos_RB = destino;
  }// Blancas

  else   // Color = negras
  {

    hash = hash ^= zobrist[contenido[origen] + 7][origen];

    if (contenido[ListaMov[MovAct].origen] == P_N)
    {
      if (origen - destino == 20)
      {
        Alpaso = origen - 10;
        hash ^= hash_alpaso[Alpaso];
      }
    }

    if (caalpaso > 0)
    {
      hash = hash ^= zobrist[P_B + 7][caalpaso];
      contenido[caalpaso] = VACIO;
      MaterialBB -= VAL_P;
      PeonesBB--;
    }

    else if (ListaMov[MovAct].capturada != VACIO)
    {
      hash = hash ^= zobrist[ListaMov[MovAct].capturada + 7][destino];
      MaterialBB -= matcapturado;

      if (matcapturado != VAL_P) FichasBB--;

      else PeonesBB--;
    }

    contenido[destino] = contenido[origen];
    contenido[origen]  = VACIO;

    if (ListaMov[MovAct].promocion != VACIO)
    {
      //** Mutiplicamos por (-1),para convertirla en ficha negra
      contenido[destino] = ListaMov[MovAct].promocion * -1;
      MaterialNN += (nuevomaterial - VAL_P);
      FichasNN++;
      PeonesNN--;
    }

    else
    {
      if (ListaMov[MovAct].enroquetipo == ENROQUECORTO)
      {
        contenido[destino + 1] = VACIO; // destino es G8)
        contenido[destino - 1] = T_N;
        enrocado_N  = true;
        hash = hash ^= zobrist[T_N + 7][H8];
        hash = hash ^= zobrist[T_N + 7][F8];
      }

      else if (ListaMov[MovAct].enroquetipo == ENROQUELARGO)
      {
        contenido[destino - 2] = VACIO;
        contenido[destino + 1] = T_N;
        enrocado_N  = true;
        hash = hash ^= zobrist[T_N + 7][A8];
        hash = hash ^= zobrist[T_N + 7][D8];
      }
    }

    hash = hash ^= zobrist[contenido[destino] + 7][destino];

    if (contenido[destino] == R_N) Pos_RN = destino;

  }//negras

  //** Cambiamos el bando al que le toca jugar
  Color = -Color;
  hash ^= hash_turno;
}

//** Deshacemos el ultimo movimiento hecho
void retrocede(void)
{
  int origen, destino, ca_cap_alpaso;

  hply--;
  origen        = historial[hply].origen;
  destino       = historial[hply].destino;
  ca_cap_alpaso = historial[hply].cap_alpaso;
  Alpaso        = historial[hply].alpaso;
  hash          = historial[hply].hash;
  fifty         = historial[hply].fifty;

  Color = -Color;
  Profundidad--;
  contenido[origen] = contenido[destino];
  contenido[destino] = VACIO;

  if (Color == BLANCAS)
  {

    //Fue una captura al paso ?..
    if ((ca_cap_alpaso > 0) && (historial[hply].capturada == P_B))
    {
      contenido[ca_cap_alpaso] = P_N;
      PeonesNN++;
      MaterialNN += VAL_P;
    }

    //Fue una captura ?...
    else if (historial[hply].capturada != VACIO)
    {
      contenido[destino] = (-1) * historial[hply].capturada;

      if (historial[hply].capturada == P_B)
      {
        PeonesNN++;
        MaterialNN += VAL_P;
      }

      else
      {
        MaterialNN += ValFicha[historial[hply].capturada];
        FichasNN++;
      }
    }

    Movida[origen]--;
    Movida[destino]--;

    // Fue enroque corto ?....
    if (historial[hply].enrocado == ENROQUECORTO)
    {
      contenido[destino + 1] = T_B;
      contenido[destino - 1] = VACIO;
      enrocado_B = false;
    }

    // Fue enroque largo ?....
    else if (historial[hply].enrocado == ENROQUELARGO)
    {
      contenido[destino - 2] = T_B;
      contenido[destino + 1] = VACIO;
      enrocado_B = false;
    }

    //Fue una promocion ?..
    if (historial[hply].promovida != VACIO)
    {
      contenido[origen] = P_B;
      PeonesBB++;
      MaterialBB += VAL_P;
      FichasBB--;
      MaterialBB -= ValFicha[historial[hply].promovida];
    }

    if (contenido[origen] == R_B) Pos_RB = origen;
  } // Blancas

//******************************************************

  else  // color = negras
  {

//Fue una captura al paso ?..
    if ((ca_cap_alpaso > 0) && (historial[hply].capturada == P_B))
    {
      contenido[ca_cap_alpaso] = P_B;
      PeonesBB++;
      MaterialBB += VAL_P;
    }

    //Fue una captura ?...
    else if (historial[hply].capturada != VACIO)
    {
      contenido[destino] = historial[hply].capturada;

      if (historial[hply].capturada == P_B)
      {
        PeonesBB++;
        MaterialBB += VAL_P;
      }

      else
      {
        MaterialBB += ValFicha[historial[hply].capturada];
        FichasBB++;
      }
    }

    Movida[origen]--;
    Movida[destino]--;

    // Fue enroque corto ?....
    if (historial[hply].enrocado == ENROQUECORTO)
    {
      contenido[destino + 1] = T_N;
      contenido[destino - 1] = VACIO;
      enrocado_N = false;
    }

    // Fue enroque largo ?....
    else if (historial[hply].enrocado == ENROQUELARGO)
    {
      contenido[destino - 2] = T_N;
      contenido[destino + 1] = VACIO;
      enrocado_N = false;
    }

    //Fue una promocion ?..
    if (historial[hply].promovida != VACIO)
    {
      contenido[origen] = P_N;
      PeonesNN++;
      MaterialNN += VAL_P;
      FichasNN--;
      MaterialNN -= ValFicha[historial[hply].promovida];
    }

    if (contenido[origen] == R_N) Pos_RN = origen;
  }// negras

}

void genera_todo(void)
{

  register  int ca = 0;
  int destino = 0;
  int fichas = 0;
  int contador = 0;

  Index = PilaMax[Profundidad];

  if (Color == BLANCAS)
  {
    fichas = 1 + PeonesBB + FichasBB;

    for (ca = A1; contador < fichas; ca++)
    {
      if (contenido[ca] < P_B ||
          contenido[ca] > R_B ) continue;

      contador++;

      switch (contenido[ca])
      {
      case P_B:
        if (contenido[ca + 10] == VACIO)
        {
          if (ca >= A7)
            anota_promocion(ca, ca + 10);

          else
          {
            anota_jugada(ca, ca + 10);

            if ((ca <= H2) && (contenido[ca + 20] == VACIO))
              anota_jugada(ca, ca + 20);
          }
        }

        if (contenido[ca + 11] < 0)
        {
          if (ca >= A7)
            anota_promocion(ca, ca + 11);

          else anota_captura(ca, ca + 11);
        }

        if (contenido[ca + 9] < 0)
        {
          if (ca >= A7)
            anota_promocion(ca, ca + 9);

          else anota_captura(ca, ca + 9);
        }

        //Miramos si podemos capturar al paso
        if (Alpaso != ILEGAL)
        {
          if (contenido[Alpaso - 9] == P_B)
          {
            anota_cap_alpaso(Alpaso - 9, Alpaso, Alpaso - 10);
          }

          if (contenido[Alpaso - 11] == P_B)
          {
            anota_cap_alpaso(Alpaso - 11, Alpaso, Alpaso - 10);
          }
        }

        break;

      case C_B:

        if (contenido[ca + 8] == VACIO) anota_jugada(ca, ca + 8);

        else if (contenido[ca + 8] < 0) anota_captura(ca, ca + 8);

        if (contenido[ca - 8] == VACIO) anota_jugada(ca, ca - 8);

        else if (contenido[ca - 8] < 0)anota_captura(ca, ca - 8);

        if (contenido[ca + 12] == VACIO) anota_jugada(ca, ca + 12);

        else if (contenido[ca + 12] < 0)anota_captura(ca, ca + 12);

        if (contenido[ca - 12] == VACIO) anota_jugada(ca, ca - 12);

        else if (contenido[ca - 12] < 0)anota_captura(ca, ca - 12);

        if (contenido[ca + 19] == VACIO) anota_jugada(ca, ca + 19);

        else if (contenido[ca + 19] < 0)anota_captura(ca, ca + 19);

        if (contenido[ca - 19] == VACIO) anota_jugada(ca, ca - 19);

        else if (contenido[ca - 19] < 0)anota_captura(ca, ca - 19);

        if (contenido[ca + 21] == VACIO) anota_jugada(ca, ca + 21);

        else if (contenido[ca + 21] < 0)anota_captura(ca, ca + 21);

        if (contenido[ca - 21] == VACIO) anota_jugada(ca, ca - 21);

        else if (contenido[ca - 21] < 0)anota_captura(ca, ca - 21);

        break;

      case D_B:
      case A_B:

        for (destino = ca + 9;; destino += 9)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] < 0)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca - 9;; destino -= 9)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] < 0)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca + 11;; destino += 11)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] < 0)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca - 11;; destino -= 11)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] < 0)
            anota_captura(ca, destino);

          break;
        }

        if (contenido[ca] == A_B)break;

      case T_B:

        for (destino = ca + 1;; destino += 1)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] < 0)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca - 1;; destino -= 1)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] < 0)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca + 10;; destino += 10)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] < 0)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca - 10;; destino -= 10)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] < 0)
            anota_captura(ca, destino);

          break;
        }

        break;

      case R_B:

        if (contenido[ca + 1] == VACIO) anota_jugada(ca, ca + 1);

        else if (contenido[ca + 1] < 0)anota_captura(ca, ca + 1);

        if (contenido[ca - 1] == VACIO) anota_jugada(ca, ca - 1);

        else if (contenido[ca - 1] < 0)anota_captura(ca, ca - 1);

        if (contenido[ca + 9] == VACIO) anota_jugada(ca, ca + 9);

        else if (contenido[ca + 9] < 0)anota_captura(ca, ca + 9);

        if (contenido[ca - 9] == VACIO) anota_jugada(ca, ca - 9);

        else if (contenido[ca - 9] < 0)anota_captura(ca, ca - 9);

        if (contenido[ca + 10] == VACIO) anota_jugada(ca, ca + 10);

        else if (contenido[ca + 10] < 0)anota_captura(ca, ca + 10);

        if (contenido[ca - 10] == VACIO) anota_jugada(ca, ca - 10);

        else if (contenido[ca - 10] < 0)anota_captura(ca, ca - 10);

        if (contenido[ca + 11] == VACIO) anota_jugada(ca, ca + 11);

        else if (contenido[ca + 11] < 0)anota_captura(ca, ca + 11);

        if (contenido[ca - 11] == VACIO) anota_jugada(ca, ca - 11);

        else if (contenido[ca - 11] < 0)anota_captura(ca, ca - 11);

        if (Movida[E1] == 0)
        {
          if (Movida[H1] == 0 &&
              (contenido[F1] == VACIO) && (contenido[G1] == VACIO) &&
              (casilla_atacada(E1, NEGRAS) == false) &&
              (casilla_atacada(F1, NEGRAS) == false))
          {
            anota_jugada(E1, G1);
            ListaMov[Index - 1].enroquetipo = ENROQUECORTO;
          }

          if (Movida[A1] == 0 &&
              (contenido[D1] == VACIO) && (contenido[C1] == VACIO) &&
              (contenido[B1] == VACIO) &&
              (casilla_atacada(E1, NEGRAS) == false) &&
              (casilla_atacada(D1, NEGRAS) == false))
          {
            anota_jugada(E1, C1);
            ListaMov[Index - 1].enroquetipo = ENROQUELARGO;
          }
        }

        break;
      }//switch
    }//for
  }// Color = Blancas

  else
  {
    fichas = 1 + PeonesNN + FichasNN;

    for (ca = H8; contador < fichas; ca--)
    {

      if (contenido[ca] > P_N) continue;

      contador++;

      switch (contenido[ca])
      {
      case P_N:
        if (contenido[ca - 10] == VACIO)
        {
          if (ca <= H2)
          {
            anota_promocion(ca, ca - 10);
          }

          else
          {
            anota_jugada(ca, ca - 10);

            if ((ca >= A7) && (contenido[ca - 20] == VACIO))
            {
              anota_jugada(ca, ca - 20);
            }
          }
        }

        if ((contenido[ca - 11] > 0) && (contenido[ca - 11] < R_B))
        {
          if (ca <= H2)
            anota_promocion(ca, ca - 11);

          else anota_captura(ca, ca - 11);
        }

        if ((contenido[ca - 9] > 0) && (contenido[ca - 9] < R_B))
        {
          if (ca <= H2)
            anota_promocion(ca, ca - 9);

          else anota_captura(ca, ca - 9);
        }

        if (Alpaso != ILEGAL)
        {
          if (contenido[Alpaso + 9] == P_N)
          {
            anota_cap_alpaso(Alpaso + 9, Alpaso, Alpaso + 10);
          }

          if (contenido[Alpaso + 11] == P_N)
          {
            anota_cap_alpaso(Alpaso + 11, Alpaso, Alpaso + 10);
          }
        }

        break;

      case C_N:

        if (contenido[ca + 8] == VACIO)anota_jugada(ca, ca + 8);

        else if (contenido[ca + 8] > 0 && contenido[ca + 8] < R_B)anota_captura(ca, ca + 8);

        if (contenido[ca - 8] == VACIO)anota_jugada(ca, ca - 8);

        else if (contenido[ca - 8] > 0 && contenido[ca - 8] < R_B)anota_captura(ca, ca - 8);

        if (contenido[ca + 12] == VACIO)anota_jugada(ca, ca + 12);

        else if (contenido[ca + 12] > 0 && contenido[ca + 12] < R_B)anota_captura(ca, ca + 12);

        if (contenido[ca - 12] == VACIO)anota_jugada(ca, ca - 12);

        else if (contenido[ca - 12] > 0 && contenido[ca - 12] < R_B)anota_captura(ca, ca - 12);

        if (contenido[ca + 19] == VACIO)anota_jugada(ca, ca + 19);

        else if (contenido[ca + 19] > 0 && contenido[ca + 19] < R_B)anota_captura(ca, ca + 19);

        if (contenido[ca - 19] == VACIO)anota_jugada(ca, ca - 19);

        else if (contenido[ca - 19] > 0 && contenido[ca - 19] < R_B)anota_captura(ca, ca - 19);

        if (contenido[ca + 21] == VACIO)anota_jugada(ca, ca + 21);

        else if (contenido[ca + 21] > 0 && contenido[ca + 21] < R_B)anota_captura(ca, ca + 21);

        if (contenido[ca - 21] == VACIO)anota_jugada(ca, ca - 21);

        else if (contenido[ca - 21] > 0 && contenido[ca - 21] < R_B)anota_captura(ca, ca - 21);

        break;

      case D_N:
      case A_N:

        for (destino = ca + 9;; destino += 9)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] > 0 && contenido[destino] < R_B)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca - 9;; destino -= 9)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] > 0 && contenido[destino] < R_B)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca + 11;; destino += 11)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] > 0 && contenido[destino] < R_B)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca - 11;; destino -= 11)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] > 0 && contenido[destino] < R_B)
            anota_captura(ca, destino);

          break;
        }

        if (contenido[ca] == A_N)break;

      case T_N:

        for (destino = ca + 1;; destino += 1)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] > 0 && contenido[destino] < R_B)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca - 1;; destino -= 1)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] > 0 && contenido[destino] < R_B)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca + 10;; destino += 10)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] > 0 && contenido[destino] < R_B)
            anota_captura(ca, destino);

          break;
        }

        for (destino = ca - 10;; destino -= 10)
        {
          if (contenido[destino] == VACIO)
          {
            anota_jugada(ca, destino);
            continue;
          }

          if (contenido[destino] > 0 && contenido[destino] < R_B)
            anota_captura(ca, destino);

          break;
        }

        break;

      case R_N:

        if (contenido[ca + 1] == VACIO )anota_jugada(ca, ca + 1);

        else if (contenido[ca + 1] > 0 && contenido[ca + 1] < R_B)anota_captura(ca, ca + 1);

        if (contenido[ca - 1] == VACIO )anota_jugada(ca, ca - 1);

        else if (contenido[ca - 1] > 0 && contenido[ca - 1] < R_B)anota_captura(ca, ca - 1);

        if (contenido[ca + 9] == VACIO )anota_jugada(ca, ca + 9);

        else if (contenido[ca + 9] > 0 && contenido[ca + 9] < R_B)anota_captura(ca, ca + 9);

        if (contenido[ca - 9] == VACIO )anota_jugada(ca, ca - 9);

        else if (contenido[ca - 9] > 0 && contenido[ca - 9] < R_B)anota_captura(ca, ca - 9);

        if (contenido[ca + 10] == VACIO )anota_jugada(ca, ca + 10);

        else if (contenido[ca + 10] > 0 && contenido[ca + 10] < R_B)anota_captura(ca, ca + 10);

        if (contenido[ca - 10] == VACIO )anota_jugada(ca, ca - 10);

        else if (contenido[ca - 10] > 0 && contenido[ca - 10] < R_B)anota_captura(ca, ca - 10);

        if (contenido[ca + 11] == VACIO )anota_jugada(ca, ca + 11);

        else if (contenido[ca + 11] > 0 && contenido[ca + 11] < R_B)anota_captura(ca, ca + 11);

        if (contenido[ca - 11] == VACIO )anota_jugada(ca, ca - 11);

        else if (contenido[ca - 11] > 0 && contenido[ca - 11] < R_B)anota_captura(ca, ca - 11);

        if (Movida[E8] == 0)
        {
          if (Movida[H8] == 0 &&
              (contenido[F8] == VACIO) && (contenido[G8] == VACIO) &&
              (casilla_atacada(E8, BLANCAS) == false) &&
              (casilla_atacada(F8, BLANCAS) == false))
          {
            anota_jugada(E8, G8);
            ListaMov[Index - 1].enroquetipo = ENROQUECORTO;
          }

          if (Movida[A8] == 0 &&
              (contenido[D8] == VACIO) && (contenido[C8] == VACIO) &&
              (contenido[B8] == VACIO) &&
              (casilla_atacada(E8, BLANCAS) == false) &&
              (casilla_atacada(D8, BLANCAS) == false))
          {
            anota_jugada(E8, C8);
            ListaMov[Index - 1].enroquetipo = ENROQUELARGO;
          }
        }

        break;
      }//switch
    }//for
  }// Color = negras

  PilaMax[Profundidad + 1] = Index;

}//Genera todo



//** Generador de capturas y promocion para Qsearch()

void genera_capturas(void)
{
  int origen, destino, fichas;
  int i;
  int contador = 0;
  Index = PilaMax[Profundidad];

  if (Color == BLANCAS)
  {
    fichas = PeonesBB + FichasBB + 1;

    for (origen = A1; contador < fichas; origen++)
    {
      if (contenido[origen] < P_B ||
          contenido[origen] > R_B ) continue;

      contador++;

      switch (contenido[origen])
      {
      case P_B:
        if (contenido[origen + 10] == VACIO)
        {
          if (origen >= A7) anota_promocionq(origen, origen + 10);
        }

        if (contenido[origen + 11] < 0)
        {
          if (origen >= A7)
            anota_promocionq(origen, origen + 11);

          else anota_capturaq(origen, origen + 11);
        }

        if (contenido[origen + 9] < 0)
        {
          if (origen >= A7)
            anota_promocionq(origen, origen + 9);

          else anota_capturaq(origen, origen + 9);
        }

        break;

      case C_B:
        for (i = 0; i < 8; i++)
        {
          if (contenido[origen + Inc_Ca[i]] < 0)
            anota_capturaq(origen, origen + Inc_Ca[i]);
        }

        break;

//case D_B:
      case A_B:
        for (i = 0; i < 4; i++)
        {
          destino = origen + Inc_Al[i];

          while (contenido[ destino ] == VACIO ) destino += Inc_Al[i];

          if ( contenido[ destino ] < 0)
            anota_capturaq(origen, destino);
        }//for

        break;

      case T_B:
        for (i = 0; i < 4; i++)
        {
          destino = origen + Inc_To[i];

          while (contenido[ destino ] == VACIO ) destino += Inc_To[i];

          if ( contenido[ destino ] < 0)
            anota_capturaq(origen, destino);
        }//for

        break;

      case D_B:
        for (i = 0; i < 8; i++)
        {
          destino = origen + Inc_Da[i];

          while (contenido[ destino ] == VACIO ) destino += Inc_Da[i];

          if ( contenido[ destino ] < 0)
            anota_capturaq(origen, destino);
        }//for

        break;

      case R_B:
        for (i = 0; i < 8; i++)
        {
          if (contenido[origen + Inc_Da[i]] < 0)
            anota_capturaq(origen, origen + Inc_Da[i]);
        }

        break;
      }//switch
    }//for
  }// Blancas

  else
  {
    fichas = PeonesNN + FichasNN + 1;

    for (origen = H8; contador < fichas; origen--)
    {

      if (contenido[origen] > P_N) continue;

      contador++;

      switch (contenido[origen])
      {
      case P_N:
        if (contenido[origen - 10] == VACIO)
        {
          if (origen <= H2)
          {
            anota_promocionq(origen, origen - 10);
          }
        }

        if ((contenido[origen - 11] > 0) && (contenido[origen - 11] != FUERA))
        {
          if (origen <= H2)
            anota_promocionq(origen, origen - 11);

          else anota_capturaq(origen, origen - 11);
        }

        if ((contenido[origen - 9] > 0) && (contenido[origen - 9] != FUERA))
        {
          if (origen <= H2)
            anota_promocionq(origen, origen - 9);

          else anota_capturaq(origen, origen - 9);
        }

        break;

      case C_N:
        for (i = 0; i < 8; i++)
        {
          if (contenido[origen + Inc_Ca[i]] > 0 &&
              contenido[origen + Inc_Ca[i]] < R_B)
            anota_capturaq(origen, origen + Inc_Ca[i]);
        }

        break;

//case D_N:
      case A_N:
        for (i = 0; i < 4; i++)
        {
          destino = origen + Inc_Al[i];

          while (contenido[ destino ] == VACIO ) destino += Inc_Al[i];

          if ( contenido[ destino ] > 0 && contenido[ destino ] < R_B)
            anota_capturaq(origen, destino);
        }//for

        break;

      case T_N:
        for (i = 0; i < 4; i++)
        {
          destino = origen + Inc_To[i];

          while (contenido[ destino ] == VACIO ) destino += Inc_To[i];

          if ( contenido[ destino ] > 0 && contenido[ destino ] < R_B)
            anota_capturaq(origen, destino);
        }//for

        break;

      case D_N:
        for (i = 0; i < 8; i++)
        {
          destino = origen + Inc_Da[i];

          while (contenido[ destino ] == VACIO ) destino += Inc_Da[i];

          if ( contenido[ destino ] > 0 && contenido[ destino ] < R_B)
            anota_capturaq(origen, destino);
        }//for

        break;

      case R_N:
        for (i = 0; i < 8; i++)
        {
          if (contenido[origen + Inc_Da[i]] > 0 &&
              contenido[origen + Inc_Da[i]] < R_B)
            anota_capturaq(origen, origen + Inc_Da[i]);
        }

        break;
      }//switch
    }//for
  }// Negras

  PilaMax[Profundidad + 1] = Index;
}

