//** MODULO PRINCIPAL ***

#if defined(__GNUC__)
#include <stdlib.h>
#define max MAX
#define min(a,b) ((a)<(b)?(a):(b))
#define Min min
#endif

#if defined(_WIN32) || defined(_WIN64)
#include <windows.h>
#endif

#include "data.h"
#include "util.h"
#include "xboard.h"
#include "gen.h"
#include "see.h"
#include "peones.h"
#include "finales.h"
#include "search.h"
#include "eval.h"
#include "hash.h"

int main(void)
{

  newgame();
  printf("\n   Betsabe II version 2023, febrero 2023 ");
  dibuja_tablero();
  lee_comando();
  return (1);
}

void newgame(void)
{
  int i, x, y;

//** Inicializamos todo los datos para una nueva partida,
//** el contenido del tablero con la posicin inicial etc...

  // terminado = false;
  maxtiempo = 20000;

//** Colocamos las fichas en su posicin inicial
  for (i = 0; i < 120; i++)
  {
    contenido[i] = Tablero_Inicio[i];
  }

//** Precalculamos la distanca entre 2 casillas, es algo mas rpido
  for (x = A1; x <= H8 + 1; x++)
  {
    for (y = A1; y <= H8 + 1; y++)
    {
      if (es_casilla(x) && es_casilla(y)) Distancia[x][y] = Dist(x, y);

      else Distancia[x][y] = 16;
    }
  }

  init_pcsq();

//** Recordemos que en todo momento tenemos que saber donde estan los reyes
//** y cada vez que se mueva un Rey, anotaremos su posicin

  Pos_RB = E1;
  Pos_RN = E8;

//** Ponemos enrocado Blanco y Negro a falso
  enrocado_B = false;
  enrocado_N = false;

//** Al principio de la partida, ninguna ficha se ha movido
  for (i = A1; i <= H8; i++)
  {
    Movida[i] = 0;
  }

  fifty = hply = 0;
  init_hash();
  set_hash();
  TTSize = ((256 * 1048576) / sizeof(TType)); // was 32
  ETSize = (16 * 1048576) / sizeof(EType);

  alloc_hash();
  clear_hash();

  Alpaso         =  ILEGAL;
  MaterialBB     =  (APERTURA / 2);
  FichasBB       =  7;
  PeonesBB       =  8;
  MaterialNN     =  (APERTURA / 2);
  FichasNN       =  7;
  PeonesNN       =  8;
  PilaMax[0]     =  0;
  MAX_PLY        =  60;
  Profundidad    =  0;
  Color          =  BLANCAS;
  Betsabe        =  NEGRAS;
  modotest       =  false;
  //Abandonar	   =  0;
  quedan         =  20;
  Analiza        =  false;
  ponderar       =  false;
  DosJugadores   =  false;
}

void Test()
{

  maxtiempo = 35000;
  MAX_PLY   = 64;
  modotest  =  true;

  printf("\n\n LCT mov Cd5-f6+ \n");
  setboard_fen("2b1r1k1/r4ppp/p7/2pNP3/4Q3/q6P/2P2PP1/3RR1K1 w - -");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  printf("\n\n LCT mov  Af4xh6 \n");
  setboard_fen("rq2rbk1/6p1/p2p2Pp/1p1Rn3/4PB2/6Q1/PPP1B3/2K3R1 w - -");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  printf("\n\n TEST MODULAR 12, (Angel Vega)   mov = Ab4!  ev > 1.0 \n");
  setboard_fen("2r2r1k/1bb1q1pp/1np5/pp2n2P/5N1N/P7/1P3PP1/K1Q1BBRR w - - ");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  printf("\n\n ULTRAFRONTERA 1 (LA Fdez.Bueno) mov = Ab1-a2, para llevar el Rey a a6 \n");
  setboard_fen("k7/B7/1P6/1P2np2/1P1p1p2/1Pp2p1p/2P4p/1BK4B w - - ");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  printf("\n\n ULTRAFRONTERA 2 (LA Fdez.Bueno)  mov = Rg8-f8, ev optima Mate \n");
  setboard_fen("6k1/4p1p1/1p2P1P1/1P2p3/1p2P3/1P2p1p1/4P1P1/5BK1 b - - ");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  printf("\n\n ULTRAFRONTERA 3 (LA Fdez.Bueno)  mov = Dh2-h3 \n");
  setboard_fen("4k3/8/p7/Pp3p1p/1Pp1pPpP/2PpP1P1/3P1KNQ/R3BNRB w - -  ");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  printf("\n\n ULTRAFRONTERA 3 (LA Fdez.Bueno)  Un mov de Rey, ev optima 0.0 \n");
  setboard_fen("8/4kb1r/2p3p1/rpPp1pPp/pP1PpP1P/P3P3/2K5/8 w - - ");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  //** MATE

  printf("\n\n TEST MODULAR 6,(Angel Vega) Mate en 11     mov Af1-b5!    \n");
  setboard_fen("k7/Pp1p4/1K2p3/5p1p/6pP/8/8/5B2 w - - ");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  printf("\n\n Fuente ??, mate-10 ,  mov = De2-h5+!! \n");
  setboard_fen("2qbr1n1/3b1kp1/2pBpn1p/1p2PP2/p2P4/1BP5/P3Q1PP/4RRK1 w - -");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  printf("\n\n TEST MODULAR 8, (Angel Vega) mov = Tf6-f8!!, ev mate en 7 \n");
  setboard_fen("8/7r/5Rp1/6p1/5pPk/5P1p/5P1K/8 w - -");
  dibuja_tablero();
  clear_hash();
  computer_mov();
  clear_hash();

  printf("\n\n TEST MODULAR 4, (Angel Vega)    mov = De3-h6+!!, ev mate \n");
  setboard_fen("r1b2r2/3pNpkp/3pn1p1/2pN3P/2PnP3/q3QP2/4BKP1/1R5R w - -");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  //**TACTICO

  printf("\n\n COMPOSICION PROPIA, mov = Th2xh7, ev optima mate  \n");
  setboard_fen("3r1bk1/6pp/3p1pP1/3pp3/8/1K1Pp3/PPP4R/5bR1 w - - ");
  dibuja_tablero();
  clear_hash();
  computer_mov();

  printf("\n\n LCT II-25-2,     mov = De1-h4+  ev > 2.0  \n");
  setboard_fen("rnbq4/p1r2p1k/1p1p1Pp1/1BpPn3/P7/2P5/6PP/R1B1QRK1 w - - ");
  dibuja_tablero();
  clear_hash();
  computer_mov();

}

/*
 if(condicion ){
		dibuja_tablero();
		printf("casilla  =  %d   \n",ca);
		getch();}
*/
